Index: /trunk/src/sh_static.c
===================================================================
--- /trunk/src/sh_static.c	(revision 584)
+++ /trunk/src/sh_static.c	(revision 1)
@@ -52,10 +52,4 @@
 #include <grp.h>
 
-#include "sh_pthread.h"
-
-extern  int sl_close_fd (const char * file, int line, int fd);
-extern  int sl_fclose (const char * file, int line, FILE * fp);
-
-
 #ifndef _PATH_PASSWD
 #define _PATH_PASSWD "/etc/passwd"
@@ -65,9 +59,4 @@
 #endif
 
-#undef  FIL__
-#define FIL__  _("sh_static.c")
-
-extern  int sl_strlcpy(char * dst, /*@null@*/const char * src, size_t siz);
-extern  int sl_strlcat(char * dst, /*@null@*/const char * src, size_t siz);
 
 
@@ -76,6 +65,5 @@
 
 #define PWD_BUFFER_SIZE 256
-#define GRP_BUFFER_SIZE 3584
-#define GRP_BUFFER_SIZE_MALLOC 32768
+#define GRP_BUFFER_SIZE 256
 
 /**********************************************************************/
@@ -102,8 +90,8 @@
 #define DO_GETXXKEY_R_PATHNAME  _PATH_PASSWD
 
-int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
-		    GETXXKEY_R_ENTTYPE *__restrict resultbuf,
-		    char *__restrict buffer, size_t buflen,
-		    GETXXKEY_R_ENTTYPE **__restrict result)
+static int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
+			   GETXXKEY_R_ENTTYPE *__restrict resultbuf,
+			   char *__restrict buffer, size_t buflen,
+			   GETXXKEY_R_ENTTYPE **__restrict result)
 {
   FILE *stream;
@@ -131,5 +119,5 @@
       }
     } while (1);
-    sl_fclose(FIL__, __LINE__, stream);
+    fclose(stream);
   }
   
@@ -150,8 +138,8 @@
 #define DO_GETXXKEY_R_PATHNAME  _PATH_GROUP
 
-int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
-		    GETXXKEY_R_ENTTYPE *__restrict resultbuf,
-		    char *__restrict buffer, size_t buflen,
-		    GETXXKEY_R_ENTTYPE **__restrict result)
+static int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
+			   GETXXKEY_R_ENTTYPE *__restrict resultbuf,
+			   char *__restrict buffer, size_t buflen,
+			   GETXXKEY_R_ENTTYPE **__restrict result)
 {
   FILE *stream;
@@ -179,5 +167,5 @@
       }
     } while (1);
-    sl_fclose(FIL__, __LINE__, stream);
+    fclose(stream);
   }
   
@@ -198,8 +186,8 @@
 #define DO_GETXXKEY_R_PATHNAME  _PATH_PASSWD
 
-int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
-		    GETXXKEY_R_ENTTYPE *__restrict resultbuf,
-		    char *__restrict buffer, size_t buflen,
-		    GETXXKEY_R_ENTTYPE **__restrict result)
+static int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
+			   GETXXKEY_R_ENTTYPE *__restrict resultbuf,
+			   char *__restrict buffer, size_t buflen,
+			   GETXXKEY_R_ENTTYPE **__restrict result)
 {
   FILE *stream;
@@ -227,5 +215,5 @@
       }
     } while (1);
-    sl_fclose(FIL__, __LINE__, stream);
+    fclose(stream);
   }
   
@@ -246,8 +234,8 @@
 #define DO_GETXXKEY_R_PATHNAME  _PATH_GROUP
 
-int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
-		    GETXXKEY_R_ENTTYPE *__restrict resultbuf,
-		    char *__restrict buffer, size_t buflen,
-		    GETXXKEY_R_ENTTYPE **__restrict result)
+static int GETXXKEY_R_FUNC(DO_GETXXKEY_R_KEYTYPE key,
+			   GETXXKEY_R_ENTTYPE *__restrict resultbuf,
+			   char *__restrict buffer, size_t buflen,
+			   GETXXKEY_R_ENTTYPE **__restrict result)
 {
   FILE *stream;
@@ -275,5 +263,5 @@
       }
     } while (1);
-    sl_fclose(FIL__, __LINE__, stream);
+    fclose(stream);
   }
   
@@ -291,9 +279,4 @@
 }
 
-struct passwd * getpwuid(uid_t uid)
-{
-        return sh_getpwuid(uid);
-}
-
 struct group * sh_getgrgid(gid_t gid)
 {
@@ -306,8 +289,4 @@
 }
 
-struct group * getgrgid(gid_t gid)
-{
-        return sh_getgrgid(gid);
-}
 
 struct passwd * sh_getpwnam(const char *name)
@@ -331,6 +310,6 @@
 }
 
-SH_MUTEX_STATIC(pwf_lock, PTHREAD_MUTEX_INITIALIZER);
-
+#define LOCK		((void) 0)
+#define UNLOCK		((void) 0)
 
 static FILE *pwf = NULL;
@@ -338,19 +317,19 @@
 void  sh_setpwent(void)
 {
-        SH_MUTEX_LOCK(pwf_lock);
+	LOCK;
 	if (pwf) {
 		rewind(pwf);
 	}
-	SH_MUTEX_UNLOCK(pwf_lock);
+	UNLOCK;
 }
 
 void  sh_endpwent(void)
 {
-        SH_MUTEX_LOCK(pwf_lock);
+	LOCK;
 	if (pwf) {
-		sl_fclose(FIL__, __LINE__, pwf);
+		fclose(pwf);
 		pwf = NULL;
 	}
-	SH_MUTEX_UNLOCK(pwf_lock);
+	UNLOCK;
 }
 
@@ -362,5 +341,5 @@
 	int rv;
 
-        SH_MUTEX_LOCK(pwf_lock);
+	LOCK;
 
 	*result = NULL;				/* In case of error... */
@@ -380,11 +359,11 @@
 
  ERR:
-	; /* 'label at end of compound statement' */
-	SH_MUTEX_UNLOCK(pwf_lock);
+	UNLOCK;
 
 	return rv;
 }
 
-SH_MUTEX_STATIC(grf_lock, PTHREAD_MUTEX_INITIALIZER);
+#define LOCK		((void) 0)
+#define UNLOCK		((void) 0)
 
 static FILE *grf = NULL;
@@ -392,19 +371,19 @@
 void  sh_setgrent(void)
 {
-	SH_MUTEX_LOCK(grf_lock);
+	LOCK;
 	if (grf) {
 		rewind(grf);
 	}
-	SH_MUTEX_UNLOCK(grf_lock);
+	UNLOCK;
 }
 
 void  sh_endgrent(void)
 {
-	SH_MUTEX_LOCK(grf_lock);
+	LOCK;
 	if (grf) {
-		sl_fclose(FIL__, __LINE__, grf);
+		fclose(grf);
 		grf = NULL;
 	}
-	SH_MUTEX_UNLOCK(grf_lock);
+	UNLOCK;
 }
 
@@ -415,5 +394,5 @@
 	int rv;
 
-	SH_MUTEX_LOCK(grf_lock);
+	LOCK;
 
 	*result = NULL;				/* In case of error... */
@@ -433,6 +412,5 @@
 
  ERR:
-	; /* 'label at end of compound statement' */
-	SH_MUTEX_UNLOCK(grf_lock);
+	UNLOCK;
 
 	return rv;
@@ -457,5 +435,5 @@
 	struct group *result;
 
-	sh_getgrent_r(&gr, line_buff, sizeof(line_buff), &result);
+	 sh_getgrent_r(&gr, line_buff, sizeof(line_buff), &result);
 	return result;
 }
@@ -464,16 +442,14 @@
 {
 	FILE *grf;
-	gid_t *group_list = NULL;
-	size_t num_groups;
-	int rv;
+	gid_t *group_list;
+	int num_groups, rv;
 	char **m;
 	struct group group;
-
-	char * buff = calloc(1,GRP_BUFFER_SIZE_MALLOC);
+	char buff[PWD_BUFFER_SIZE];
 
 	rv = -1;
 
 	/* We alloc space for 8 gids at a time. */
-	if (buff && ((group_list = calloc(8,sizeof(gid_t *))) != NULL)
+	if (((group_list = (gid_t *) malloc(8*sizeof(gid_t *))) != NULL)
 		&& ((grf = fopen(_PATH_GROUP, "r")) != NULL)
 		) {
@@ -484,5 +460,5 @@
 		num_groups = 1;
 
-		while (!__pgsreader(__parsegrent, &group, buff, GRP_BUFFER_SIZE_MALLOC, grf)) {
+		while (!__pgsreader(__parsegrent, &group, buff, sizeof(buff), grf)) {
 			assert(group.gr_mem); /* Must have at least a NULL terminator. */
 			if (group.gr_gid != gid) {
@@ -490,19 +466,12 @@
 					if (!strcmp(*m, user)) {
 						if (!(num_groups & 7)) {
-						  gid_t *tmp = NULL;
-						  if (num_groups > (SIZE_MAX - 8)) {
-						    rv = -1;
-						    goto DO_CLOSE;
-						  }
-						  if ((num_groups+8) <= (SIZE_MAX / sizeof(gid_t *))) {
-						    tmp = (gid_t *)
-						      realloc(group_list,
-							      (num_groups+8) * sizeof(gid_t *));
-						  } 
-						  if (!tmp) {
-						    rv = -1;
-						    goto DO_CLOSE;
-						  }
-						  group_list = tmp;
+							gid_t *tmp = (gid_t *)
+								realloc(group_list,
+										(num_groups+8) * sizeof(gid_t *));
+							if (!tmp) {
+								rv = -1;
+								goto DO_CLOSE;
+							}
+							group_list = tmp;
 						}
 						group_list[num_groups++] = group.gr_gid;
@@ -515,12 +484,10 @@
 		rv = setgroups(num_groups, group_list);
 	DO_CLOSE:
-		sl_fclose(FIL__, __LINE__, grf);
+		fclose(grf);
 	}
 
 	/* group_list will be NULL if initial malloc failed, which may trigger
 	 * warnings from various malloc debuggers. */
-	if (group_list) free(group_list);
-	if (buff) free(buff);
-	/* cppcheck-suppress resourceLeak */
+	free(group_list);
 	return rv;
 }
@@ -700,6 +667,6 @@
 		skip = 0;
 		do {
-			if (!fgets(line_buff, buflen, f)) {
-				if (feof(f)) {
+			if (!fgets_unlocked(line_buff, buflen, f)) {
+				if (feof_unlocked(f)) {
 					rv = ENOENT;
 				}
@@ -711,10 +678,6 @@
 				line_buff[line_len] = 0;
 			} else if (line_len + 2 == buflen) { /* line too long */
-			        rv = ERANGE;
-				break;
-				/*
 				++skip;
 				continue;
-				*/
 			}
 
@@ -886,5 +849,5 @@
 #include <arpa/inet.h>
 
-/* sl_close_fd(FIL__, __LINE__, )
+/* close()
  */
 #include <unistd.h>
@@ -898,5 +861,6 @@
 #include <arpa/nameser.h>
 
-SH_MUTEX_STATIC(resolv_lock, PTHREAD_MUTEX_INITIALIZER);
+#define BIGLOCK
+#define BIGUNLOCK
 
 #define __UCLIBC_HAS_IPV6__
@@ -917,8 +881,7 @@
 
 #undef DEBUG
-/* #define DEBUG */
+/*#define DEBUG*/
 
 #ifdef DEBUG
-/* flawfinder: ignore *//* definition of debug macro */
 #define DPRINTF(X,args...) fprintf(stderr, X, ##args)
 #else
@@ -1008,31 +971,14 @@
 		return -1;
 
-	do {
-		l = data[offset];
-		if (offset < INT_MAX)
-	                offset++;
-		else
-		        return -1;
-		if (!l)
-		  break;
-		
-		DPRINTF("l[%d] = %d\n", offset, l);
+	while ((l = data[offset++])) {
 
 		if ((l & 0xc0) == (0xc0)) {
-		        if (offset < INT_MAX)
-			  offset++;
-			else
-			  return -1;
+			offset++;
 			break;
 		}
 
-		if (offset <= (INT_MAX - l))
-		  offset += l;
-		else
-		  return -1;
-
-	} while (l);
-
-	DPRINTF("orig: %d now %d\n", orig_offset, offset);
+		offset += l;
+	}
+
 	return offset - orig_offset;
 }
@@ -1045,8 +991,6 @@
 	if (i < 0)
 		return i;
-	if (i < (INT_MAX - 4))
-	  return i + 4;
-	else
-	  return -1;
+
+	return i + 4;
 }
 
@@ -1064,44 +1008,26 @@
 	if (!data)
 		return -1;
-	if ((offset < 0) || (offset > (PACKETSZ-1)))
-	        return -1;
-	while ((l=data[offset])) {
-	        if (offset < (PACKETSZ-1)) offset++;
-		else return -1;
+
+	while ((l=data[offset++])) {
 		if (measure)
-		    { if (total < INT_MAX) total++; else return -1; }
+		    total++;
 		if ((l & 0xc0) == (0xc0)) {
-		        if (measure)
-			  { if (total < INT_MAX) total++; else return -1; }
-		        /* compressed item, redirect */ 
+			if (measure)
+				total++;
+			/* compressed item, redirect */
 			offset = ((l & 0x3f) << 8) | data[offset];
-			if ((offset < 0) || (offset > (PACKETSZ-1)))
-			  return -1; 
 			measure = 0;
 			continue;
 		}
-	        
-		if (used >= (INT_MAX - l))
-		  return -1;
 
 		if ((used + l + 1) >= maxlen)
-		  return -1; 
+			return -1;
 
 		memcpy(dest + used, data + offset, l);
-		
-		if (offset <= ((PACKETSZ-1) - l))
-		  offset += l;
-		else
-		  return -1;
-
-		if (used <= (INT_MAX - l))
-		  used += l;
-		else
-		  return -1;
+		offset += l;
+		used += l;
 		if (measure)
-		  { if (total <= (INT_MAX -l)) total += l; else return -1; }
-
-		if (used >= maxlen)
-		  return -1;
+			total += l;
+
 		if (data[offset] != 0)
 			dest[used++] = '.';
@@ -1112,5 +1038,5 @@
 	/* The null byte must be counted too */
 	if (measure) {
-	    if (total < INT_MAX) total++; else return -1; 
+	    total++;
 	}
 
@@ -1124,14 +1050,11 @@
 {
 	char temp[256];
-	int i = 0;
+	int i;
 
 	i = __decode_dotted(message, offset, temp, sizeof(temp));
-	if (i < 0 || i > PACKETSZ)
-		return -1;
-
-	if (offset <= ((PACKETSZ - 10) - i))
-	  message += offset + i;
-	else
-	  return -1;
+	if (i < 0)
+		return i;
+
+	message += offset + i;
 
 	a->dotted = strdup(temp);
@@ -1150,12 +1073,5 @@
 	DPRINTF("i=%d,rdlength=%d\n", i, a->rdlength);
 
-	if (RRFIXEDSZ <= (INT_MAX - i))
-	  i += RRFIXEDSZ;
-	else
-	  return -1;
-	if (a->rdlength <= (INT_MAX - i))
-	  return i + a->rdlength;
-	else
-	  return -1;
+	return i + RRFIXEDSZ + a->rdlength;
 }
 
@@ -1204,6 +1120,4 @@
 
 	dest += i;
-	if (maxlen < i)
-	  return -1;
 	maxlen -= i;
 
@@ -1216,8 +1130,5 @@
 	dest[3] = (q->qclass & 0x00ff) >> 0;
 
-	if (i <= (INT_MAX - 4))
-	  return i + 4;
-	else
-	  return -1;
+	return i + 4;
 }
 
@@ -1238,6 +1149,6 @@
 	struct resolv_question q;
 	int retries = 0;
-	unsigned char * packet = calloc(1,PACKETSZ);
-	char *dns, *lookup = calloc(1,MAXDNAME);
+	unsigned char * packet = malloc(PACKETSZ);
+	char *dns, *lookup = malloc(MAXDNAME);
 	int variant = 0;
 	struct sockaddr_in sa;
@@ -1254,11 +1165,11 @@
 	DPRINTF("Looking up type %d answer for '%s'\n", type, name);
 
-	SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+	LOCK;
 	ns %= nscount;
-	SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+	UNLOCK;
 
 	while (retries++ < MAX_RETRIES) {
 		if (fd != -1)
-			sl_close_fd(FIL__, __LINE__, fd);
+			close(fd);
 
 		memset(packet, 0, PACKETSZ);
@@ -1267,15 +1178,15 @@
 
 		/* Mess with globals while under lock */
-		SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+		LOCK;
 		++id;
 		id &= 0xffff;
 		h.id = id;
 		dns = nsip[ns];
-		SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+		UNLOCK;
 
 		h.qdcount = 1;
 		h.rd = 1;
 
-		DPRINTF("encoding header %d\n", h.rd);
+		DPRINTF("encoding header\n", h.rd);
 
 		i = __encode_header(&h, packet, PACKETSZ);
@@ -1283,12 +1194,12 @@
 			goto fail;
 
-		sl_strlcpy(lookup,name,MAXDNAME);
-		SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+		strncpy(lookup,name,MAXDNAME);
+		BIGLOCK;
 		if (variant < __searchdomains && strchr(lookup, '.') == NULL)
 		{
-		    sl_strlcat(lookup,".", MAXDNAME);
-		    sl_strlcat(lookup,__searchdomain[variant], MAXDNAME);
-		}
-		SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+		    strncat(lookup,".", MAXDNAME);
+		    strncat(lookup,__searchdomain[variant], MAXDNAME);
+		}
+		BIGUNLOCK;
 		DPRINTF("lookup name: %s\n", lookup);
 		q.dotted = (char *)lookup;
@@ -1363,16 +1274,15 @@
 		}
 
-		/* ok because we have checked that recv at least HFIXEDSZ */
 		__decode_header(packet, &h);
 
 		DPRINTF("id = %d, qr = %d\n", h.id, h.qr);
 
-		SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+		LOCK;
 		if ((h.id != id) || (!h.qr)) {
-			SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+			UNLOCK;
 			/* unsolicited */
 			goto again;
 		}
-		SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+		UNLOCK;
 
 
@@ -1397,6 +1307,4 @@
 				goto again;
 			pos += i;
-			if (pos >= PACKETSZ)
-			        goto again;
 		}
 		DPRINTF("Decoding answer at pos %d\n", pos);
@@ -1417,6 +1325,4 @@
 		    free(a->dotted);
 		    pos += i;
-		    if (pos >= PACKETSZ)
-		            goto again;
 		}
 
@@ -1424,5 +1330,5 @@
 		DPRINTF("Answer type = |%d|\n", a->atype);
 
-		sl_close_fd(FIL__, __LINE__, fd);
+		close(fd);
 
 		if (outpacket)
@@ -1439,7 +1345,7 @@
 		    int sdomains;
 
-		    SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+		    BIGLOCK;
 		    sdomains=__searchdomains;
-		    SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+		    BIGUNLOCK;
 		    variant = 0;
 		    if (retries >= nscount*(sdomains+1))
@@ -1451,7 +1357,7 @@
 		{
 		    int sdomains;
-		    SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+		    BIGLOCK;
 		    sdomains=__searchdomains;
-		    SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+		    BIGUNLOCK;
 
 		    if (variant < sdomains) {
@@ -1460,7 +1366,7 @@
 		    } else {
 			/* next server, first search */
-			SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+			LOCK;
 			ns = (ns + 1) % nscount;
-			SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+			UNLOCK;
 			variant = 0;
 		    }
@@ -1470,5 +1376,5 @@
 fail:
 	if (fd != -1)
-	    sl_close_fd(FIL__, __LINE__, fd);
+	    close(fd);
 	if (lookup)
 	    free(lookup);
@@ -1483,5 +1389,4 @@
 		*fp = fopen("/etc/config/hosts", "r");
 	}
-	/* cppcheck-suppress resourceLeak */
 	return;
 }
@@ -1559,7 +1464,4 @@
 
 	*h_errnop=HOST_NOT_FOUND;
-	if (fp == NULL) {
-	        return ret;
-	}
 	while (fgets(buf, buflen, fp)) {
 		if ((cp = strchr(buf, '#')))
@@ -1630,10 +1532,10 @@
         
 		if (action!=GETHOSTENT) {
-			sl_fclose(FIL__, __LINE__, fp);
+			fclose(fp);
 		}
 		return ret;
 	}
 	if (action!=GETHOSTENT) {
-		sl_fclose(FIL__, __LINE__, fp);
+		fclose(fp);
 	}
 	return ret;
@@ -1653,5 +1555,5 @@
 }
 
-static int __open_nameservers(void)
+static int __open_nameservers()
 {
 	FILE *fp;
@@ -1661,7 +1563,8 @@
 	int argc;
 
-	SH_MUTEX_LOCK(resolv_lock);
-	if (__nameservers > 0) {
-	  goto the_end;
+	BIGLOCK;
+	if (__nameservers > 0) { 
+	    BIGUNLOCK;
+	    return 0;
 	}
 
@@ -1703,13 +1606,10 @@
 			}
 		}
-		sl_fclose(FIL__, __LINE__, fp);
+		fclose(fp);
 	} else {
 	    DPRINTF("failed to open %s\n", "resolv.conf");
 	}
 	DPRINTF("nameservers = %d\n", __nameservers);
- the_end:
-	; /* 'label at end of compound statement' */
-	SH_MUTEX_UNLOCK(resolv_lock);
-	/* cppcheck-suppress resourceLeak */
+	BIGUNLOCK;
 	return 0;
 }
@@ -1730,5 +1630,4 @@
 	char ** __nameserverXX;
 
-	DPRINTF("sh_gethostbyname_r: /%s/\n", name);
 	__open_nameservers();
 
@@ -1774,5 +1673,5 @@
 	if (buflen<256)
 		return ERANGE;
-	strncpy(buf, name, buflen-1);
+	strncpy(buf, name, buflen);
 
 	/* First check if this is already an address */
@@ -1789,8 +1688,8 @@
 	for (;;) {
 
-	SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+	BIGLOCK;
 	__nameserversXX=__nameservers;
 	__nameserverXX=__nameserver;
-	SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+	BIGUNLOCK;
 		i = __dns_lookup(buf, T_A, __nameserversXX, __nameserverXX, &packet, &a);
 
@@ -1801,5 +1700,5 @@
 		}
 
-		strncpy(buf, a.dotted, buflen-1);
+		strncpy(buf, a.dotted, buflen);
 		free(a.dotted);
 
@@ -1831,5 +1730,4 @@
 			free(packet);
 			*h_errnop=HOST_NOT_FOUND;
-			DPRINTF("host_not_found\n");
 			return TRY_AGAIN;
 		}
@@ -1843,12 +1741,12 @@
 struct hostent * sh_gethostbyname(const char *name)
 {
-        static struct hostent h = { NULL, NULL, 0, 0, NULL};
+	static struct hostent h;
 	static char buf[sizeof(struct in_addr) +
 			sizeof(struct in_addr *)*2 +
 			sizeof(char *)*(ALIAS_DIM) + 256/*namebuffer*/ + 32/* margin */];
 	struct hostent *hp;
-	
-	DPRINTF("sh_gethostbyname: /%s/\n", name);
+
 	sh_gethostbyname_r(name, &h, buf, sizeof(buf), &hp, &h_errno);
+
 	return hp;
 }
@@ -1909,5 +1807,4 @@
 	char ** __nameserverXX;
 
-	DPRINTF("sh_gethostbyaddr_r called\n");
 	*result=NULL;
 	if (!addr)
@@ -1984,5 +1881,5 @@
 
 	if(type == AF_INET) {
-		const unsigned char *tmp_addr = (const unsigned char *)addr;
+		unsigned char *tmp_addr = (unsigned char *)addr;
 
 		memcpy(&in->s_addr, addr, len);
@@ -2011,8 +1908,8 @@
 	for (;;) {
 
-	SH_MUTEX_LOCK_UNSAFE(resolv_lock);
+	BIGLOCK;
 	__nameserversXX=__nameservers;
 	__nameserverXX=__nameserver;
-	SH_MUTEX_UNLOCK_UNSAFE(resolv_lock);
+	BIGUNLOCK;
 		i = __dns_lookup(buf, T_PTR, __nameserversXX, __nameserverXX, &packet, &a);
 
@@ -2022,5 +1919,5 @@
 		}
 
-		strncpy(buf, a.dotted, buflen-1);
+		strncpy(buf, a.dotted, buflen);
 		free(a.dotted);
 
@@ -2080,5 +1977,4 @@
 	struct hostent *hp;
 
-	DPRINTF("sh_gethostbyaddr called\n");
 	sh_gethostbyaddr_r(addr, len, type, &h, buf, sizeof(buf), &hp, &h_errno);
         
